//+------------------------------------------------------------------+
//|                                                 30pipsSystem.mq4 |
//|                                                             tsuok|
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

extern int extPips = 30;
extern int extPipsOffset = 0;
extern double extSizeRatio = 0.0125;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){return(0);}
int deinit(){return(0);}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{

	double price = (Bid + Ask) / 2;
	double keyPrice = GetKeyPrice(price);
	if(IsNear(price, keyPrice))
	{
		TakeProfit(keyPrice);
		TakePosition(keyPrice);
	}
	//LosCut(price);
	return(0);
}

//+------------------------------------------------------------------+
double GetKeyPrice(double price)
{
	double d = MathRound(price / (extPips * Point));
	return(d * (extPips * Point) + (extPipsOffset * Point));
}
bool IsNear(double v1, double v2)
{
	double d = (v1 - v2) / Point;
	return(d >= -2 && d <= 2);
}
//+------------------------------------------------------------------+
//comment is like "1.2700_1.2730" means open price and tp price.
void TakePosition(double keyPrice)
{
	string comment_long = DoubleToStr(keyPrice, Digits) + "_" + DoubleToStr((keyPrice + extPips * Point), Digits);
	string comment_short = DoubleToStr(keyPrice, Digits) + "_" + DoubleToStr((keyPrice - extPips * Point), Digits);
	//Print ("long: " + comment_long + " ,short:  " + comment_short);
	bool no_same_long = true;
	bool no_same_short = true;
	for(int i = 0; i < OrdersTotal(); i++)
	{
		if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false)
		{
			Alert("OrderSelect retruned Error " + GetLastError());
			return(-1);
		}
		if(OrderComment() == comment_long) no_same_long = false;
		if(OrderComment() == comment_short) no_same_short = false;		
	}
	
	double lot = GetLotSize();
	
	if(no_same_long)
	{
		Print("no_same_long");
		OrderSend(Symbol(), OP_BUY, lot, Ask, 0, 0, 0, comment_long, 0, 0, Blue);
	}
	if(no_same_short)
	{
		OrderSend(Symbol(), OP_SELL, lot, Bid, 0, 0, 0, comment_short, 0, 0, Red);		
		Print("no_same_short");
	}
}

double GetLotSize()
{
	double unit =  (AccountBalance() * extSizeRatio) / (extPips * Point);
	double lot = unit * 0.00001 ;
	return(lot);
}

void TakeProfit(double keyPrice)
{
	for(int i = 0; i < OrdersTotal(); i++)
	{
		if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false)
		{
			Alert("OrderSelect retruned Error " + GetLastError());
			return(-1);
		}
		
		int pos = StringFind(OrderComment(), "_", 0);
		double tp  = StrToDouble(StringSubstr(OrderComment(), pos + 1));
		
		if (keyPrice == tp)
		{
			Print("tp = " + tp);
			if(OrderType() == OP_BUY)
				OrderClose(OrderTicket(), OrderLots(), Bid, 0, Green);
			if(OrderType() == OP_SELL)
				OrderClose(OrderTicket(), OrderLots(), Ask, 0, Pink);
			//G[
		}
	}
}
